package de.jottyfan.gta.gdp.block;

import de.jottyfan.gta.gdp.GTAGDP;
import net.fabricmc.fabric.api.itemgroup.v1.ItemGroupEvents;
import net.minecraft.block.AbstractBlock;
import net.minecraft.block.Block;
import net.minecraft.item.BlockItem;
import net.minecraft.item.Item;
import net.minecraft.item.ItemGroups;
import net.minecraft.registry.Registries;
import net.minecraft.registry.Registry;
import net.minecraft.registry.RegistryKey;
import net.minecraft.registry.RegistryKeys;
import net.minecraft.sound.BlockSoundGroup;
import net.minecraft.util.Identifier;

/**
 *
 * @author jotty
 *
 */
public class ModBlocks {

	public static final Block RUBY_BLOCK = registerRubyBlock(Identifier.of(GTAGDP.MOD_ID, "ruby_block"),
			AbstractBlock.Settings.create().strength(4f).requiresTool().sounds(BlockSoundGroup.AMETHYST_BLOCK)
			.luminance(state -> state.get(RubyBlock.ACTIVATED) ? 15 : 0));
	public static final Block RUBY_ORE = registerBlock(Identifier.of(GTAGDP.MOD_ID, "ruby_ore"),
			AbstractBlock.Settings.create().strength(3f).requiresTool());
	public static final Block RUBY_DEEPSLATE_ORE = registerBlock(Identifier.of(GTAGDP.MOD_ID, "ruby_deepslate_ore"),
			AbstractBlock.Settings.create().strength(3f).requiresTool());

	private static Block registerRubyBlock(Identifier identifier, Block.Settings settings) {
		Block block = new RubyBlock(settings.registryKey(RegistryKey.of(RegistryKeys.BLOCK, identifier)));
		registerBlockItem(identifier, block, new Item.Settings());
		return Registry.register(Registries.BLOCK, identifier, block);
	}

	private static Block registerBlock(Identifier identifier, Block.Settings settings) {
		Block block = new Block(settings.registryKey(RegistryKey.of(RegistryKeys.BLOCK, identifier)));
		registerBlockItem(identifier, block, new Item.Settings());
		return Registry.register(Registries.BLOCK, identifier, block);
	}

	private static void registerBlockItem(Identifier identifier, Block block, Item.Settings settings) {
		Registry.register(Registries.ITEM, identifier, new BlockItem(block,
				settings.useBlockPrefixedTranslationKey().registryKey(RegistryKey.of(RegistryKeys.ITEM, identifier))));
	}

	public static void registerModBlocks() {
		GTAGDP.LOGGER.info("Registering Mod Blocks for {}", GTAGDP.MOD_ID);

		ItemGroupEvents.modifyEntriesEvent(ItemGroups.BUILDING_BLOCKS).register(entries -> {
			entries.add(RUBY_BLOCK);
			entries.add(RUBY_ORE);
			entries.add(RUBY_DEEPSLATE_ORE);
		});
	}
}
