package de.jottyfan.gta.gdp.item;

import de.jottyfan.gta.gdp.GTAGDP;
import net.fabricmc.fabric.api.itemgroup.v1.ItemGroupEvents;
import net.minecraft.item.Item;
import net.minecraft.item.Item.Settings;
import net.minecraft.item.ItemGroups;
import net.minecraft.registry.Registries;
import net.minecraft.registry.Registry;
import net.minecraft.registry.RegistryKey;
import net.minecraft.registry.RegistryKeys;
import net.minecraft.util.Identifier;

/**
 *
 * @author jotty
 *
 */
public class ModItems {

	public static final Item STUB = registerStubItem(
			Identifier.of(GTAGDP.MOD_ID, "stub"),
			  new Item.Settings().food(ModFoodComponents.DELICIOUS_STUB));

	public static final Item RUBYBALL = registerItem(Identifier.of(GTAGDP.MOD_ID, "rubyball"), new Item.Settings());

	private static Item registerItem(Identifier identifier, Settings settings) {
		return Registry.register(Registries.ITEM, identifier,
				new Item(settings.useItemPrefixedTranslationKey().registryKey(RegistryKey.of(RegistryKeys.ITEM, identifier))));
	}

	private static Item registerStubItem(Identifier identifier, Settings settings) {
		return Registry.register(Registries.ITEM, identifier, new StubItem(
				settings.useItemPrefixedTranslationKey().registryKey(RegistryKey.of(RegistryKeys.ITEM, identifier))));
	}

	public static void registerModItems() {
		GTAGDP.LOGGER.info("registering mod items for " + GTAGDP.MOD_ID);

		ItemGroupEvents.modifyEntriesEvent(ItemGroups.TOOLS).register(entries -> {
			entries.add(STUB);
			entries.add(RUBYBALL);
		});
	}
}
